"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("manate/react");
var react_2 = __importStar(require("react"));
var Toolbar = function (props) {
    var store = props.store;
    var modals = store.modals;
    var stylingClicked = function (modifier) {
        var editor = store.editor;
        var mainSelection = editor.state.selection.main;
        if (mainSelection.empty) {
            var word = editor.state.wordAt(mainSelection.head);
            if (word) {
                editor.dispatch({
                    selection: { anchor: word.from, head: word.to },
                });
            }
        }
        mainSelection = editor.state.selection.main; // don't forget to update this variable
        editor.dispatch({
            changes: {
                from: mainSelection.from,
                to: mainSelection.to,
                insert: "".concat(modifier).concat(editor.state.sliceDoc(mainSelection.from, mainSelection.to)).concat(modifier),
            },
        });
    };
    var listClicked = function (prefix) {
        var editor = store.editor;
        var startLine = editor.state.doc.lineAt(editor.state.selection.main.from);
        var endLine = editor.state.doc.lineAt(editor.state.selection.main.to);
        for (var i = startLine.number; i <= endLine.number; i++) {
            var line = editor.state.doc.line(i);
            editor.dispatch({
                changes: {
                    from: line.from,
                    to: line.from,
                    insert: prefix,
                },
            });
        }
    };
    var insertFence = function (type, sample) {
        var editor = store.editor;
        var mainSelection = editor.state.selection.main;
        var text = editor.state.sliceDoc(mainSelection.from, mainSelection.to) || sample;
        editor.dispatch({
            changes: {
                from: mainSelection.from,
                to: mainSelection.to,
                insert: "\n```".concat(type, "\n").concat(text, "\n```\n"),
            },
        });
    };
    return (react_2.default.createElement("div", { className: "toolbar" }, store.preferences.toolbarItems.map(function (item, index) {
        var reactElement;
        if (typeof item === 'string') {
            switch (item) {
                case 'about': {
                    reactElement = (react_2.default.createElement("img", { src: "https://markpluslabs.github.io/react-markplus/icon.svg", className: "about-icon", onClick: function () { return modals.about.open(); }, title: "About" }));
                    break;
                }
                case '|': {
                    reactElement = react_2.default.createElement("span", { className: "dividor" }, "|");
                    break;
                }
                case 'bold': {
                    reactElement = (react_2.default.createElement("i", { title: "Bold", className: "fa fa-bold", onClick: function () { return stylingClicked('**'); } }));
                    break;
                }
                case 'italic': {
                    reactElement = (react_2.default.createElement("i", { title: "Italic", className: "fa fa-italic", onClick: function () { return stylingClicked('*'); } }));
                    break;
                }
                case 'strikethrough': {
                    reactElement = (react_2.default.createElement("i", { title: "Strikethrough", className: "fa fa-strikethrough", onClick: function () { return stylingClicked('~~'); } }));
                    break;
                }
                case 'underline': {
                    reactElement = (react_2.default.createElement("i", { title: "Underline", className: "fa fa-underline", onClick: function () { return stylingClicked('++'); } }));
                    break;
                }
                case 'mark': {
                    reactElement = (react_2.default.createElement("i", { title: "Mark", className: "fa fa-marker", onClick: function () { return stylingClicked('=='); } }));
                    break;
                }
                case 'emoji': {
                    reactElement = (react_2.default.createElement("i", { title: "Emoji", className: "fa fa-regular fa-smile", onClick: function () { return modals.emoji.open(); } }));
                    break;
                }
                case 'fontawesome': {
                    reactElement = (react_2.default.createElement("i", { title: "Font awesome", className: "fa fa-regular fa-flag", onClick: function () { return modals.fontAwesome.open(); } }));
                    break;
                }
                case 'quote': {
                    reactElement = (react_2.default.createElement("i", { title: 'Quote', className: "fa fa-quote-left", onClick: function () { return listClicked('> '); } }));
                    break;
                }
                case 'unordered-list': {
                    reactElement = (react_2.default.createElement("i", { title: 'Unordered list', className: "fa fa-list-ul", onClick: function () { return listClicked('- '); } }));
                    break;
                }
                case 'ordered-list': {
                    reactElement = (react_2.default.createElement("i", { title: 'Ordered list', className: "fa fa-list-ol", onClick: function () { return listClicked('1. '); } }));
                    break;
                }
                case 'unchecked-list': {
                    reactElement = (react_2.default.createElement("i", { title: 'Unchecked list', className: "fa fa-regular fa-square", onClick: function () { return listClicked('- [ ] '); } }));
                    break;
                }
                case 'checked-list': {
                    reactElement = (react_2.default.createElement("i", { title: 'Checked list', className: "fa fa-regular fa-check-square", onClick: function () { return listClicked('- [x] '); } }));
                    break;
                }
                case 'link': {
                    reactElement = (react_2.default.createElement("i", { title: "Link", className: "fa fa-link", onClick: function () {
                            var editor = store.editor;
                            var mainSelection = editor.state.selection.main;
                            var text = editor.state.sliceDoc(mainSelection.from, mainSelection.to) || 'link';
                            editor.dispatch({
                                changes: {
                                    from: mainSelection.from,
                                    to: mainSelection.to,
                                    insert: "[".concat(text, "](https://github.com/markpluslabs/react-markplus/)"),
                                },
                            });
                        } }));
                    break;
                }
                case 'image': {
                    reactElement = (react_2.default.createElement("i", { title: "Image", className: "fa fa-regular fa-image", onClick: function () {
                            var editor = store.editor;
                            var mainSelection = editor.state.selection.main;
                            var text = editor.state.sliceDoc(mainSelection.from, mainSelection.to) || 'image';
                            editor.dispatch({
                                changes: {
                                    from: mainSelection.from,
                                    to: mainSelection.to,
                                    insert: "![".concat(text, "](https://markpluslabs.github.io/react-markplus/icon.svg)"),
                                },
                            });
                        } }));
                    break;
                }
                case 'code': {
                    reactElement = (react_2.default.createElement("i", { title: "Code", className: "fa fa-code", onClick: function () {
                            var editor = store.editor;
                            var mainSelection = editor.state.selection.main;
                            var text = editor.state.sliceDoc(mainSelection.from, mainSelection.to) || "console.log('Hello, world!');";
                            editor.dispatch({
                                changes: {
                                    from: mainSelection.from,
                                    to: mainSelection.to,
                                    insert: "\n```\n".concat(text, "\n```\n"),
                                },
                            });
                        } }));
                    break;
                }
                case 'table': {
                    reactElement = (react_2.default.createElement("i", { title: "Table", className: "fa fa-table", onClick: function () {
                            var sample = "\nheader 1 | header 2\n---|---\nrow 1 col 1 | row 1 col 2\nrow 2 col 1 | row 2 col 2".trim();
                            var editor = store.editor;
                            var cursorPos = editor.state.selection.main.head;
                            var currentLine = editor.state.doc.lineAt(cursorPos);
                            var isAtLineStart = cursorPos === currentLine.from;
                            if (isAtLineStart) {
                                editor.dispatch({
                                    changes: {
                                        from: currentLine.from,
                                        to: currentLine.from,
                                        insert: "\n".concat(sample, "\n\n"),
                                    },
                                });
                            }
                            else {
                                editor.dispatch({
                                    changes: {
                                        from: currentLine.to,
                                        to: currentLine.to,
                                        insert: "\n\n".concat(sample, "\n"),
                                    },
                                });
                            }
                        } }));
                    break;
                }
                case 'math': {
                    reactElement = (react_2.default.createElement("i", { title: "Math", className: "fa fa-square-root-variable", onClick: function () {
                            var editor = store.editor;
                            var mainSelection = editor.state.selection.main;
                            var text = editor.state.sliceDoc(mainSelection.from, mainSelection.to) || 'E = mc^2';
                            editor.dispatch({
                                changes: {
                                    from: mainSelection.from,
                                    to: mainSelection.to,
                                    insert: "\n```math\n".concat(text, "\n```\n"),
                                },
                            });
                        } }));
                    break;
                }
                case 'mermaid': {
                    reactElement = (react_2.default.createElement("i", { title: "Mermaid chart", className: "fa fa-diagram-project", onClick: function () { return insertFence('mermaid', 'graph LR\nA-->B'); } }));
                    break;
                }
                case 'chartjs': {
                    reactElement = (react_2.default.createElement("i", { title: "Chart.js chart", className: "fa fa-chart-column", onClick: function () {
                            return insertFence('chartjs', "{\n  \"type\": \"bar\",\n  \"data\": {\n    \"labels\": [\n      \"last year\",\n      \"this year\"\n    ],\n    \"datasets\": [\n      {\n        \"label\": \"# of Rainy Days\",\n        \"data\": [\n          60,\n          30\n        ]\n      }\n    ]\n  }\n}");
                        } }));
                    break;
                }
                default: {
                    throw new Error("Unknown toolbar item: ".concat(item));
                }
            }
        }
        else {
            reactElement = item;
        }
        return (0, react_2.cloneElement)(reactElement, { key: "item-".concat(index) });
    })));
};
exports.default = (0, react_1.auto)(Toolbar);
//# sourceMappingURL=toolbar.js.map