"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultToolbarItems = void 0;
var antd_1 = require("antd");
var react_1 = __importStar(require("react"));
var layout_1 = __importDefault(require("./components/layout"));
require("./css/index.scss");
require("katex/dist/katex.css");
require("@fortawesome/fontawesome-free/css/all.css");
var manate_1 = require("manate");
var store_1 = require("./store");
exports.defaultToolbarItems = [
    'about',
    '|',
    'bold',
    'italic',
    'strikethrough',
    'underline',
    'mark',
    '|',
    'emoji',
    'fontawesome',
    '|',
    'quote',
    'unordered-list',
    'ordered-list',
    'unchecked-list',
    'checked-list',
    '|',
    'link',
    'image',
    'code',
    'table',
    '|',
    'math',
    'mermaid',
    'chartjs',
];
var MarkPlus = function (props) {
    var markdown = props.markdown, mode = props.mode, toolbar = props.toolbar, theme = props.theme, toolbarItems = props.toolbarItems;
    var store = (0, react_1.useMemo)(function () {
        return (0, manate_1.manage)(new store_1.Store());
    }, []);
    (0, react_1.useEffect)(function () {
        var _a, _b;
        store.preferences.mode = mode !== null && mode !== void 0 ? mode : 'both';
        store.preferences.toolbar = toolbar !== null && toolbar !== void 0 ? toolbar : 'show';
        store.preferences.theme = theme !== null && theme !== void 0 ? theme : 'auto';
        store.preferences.toolbarItems = toolbarItems !== null && toolbarItems !== void 0 ? toolbarItems : exports.defaultToolbarItems;
        store.onChange = (_a = props.onChange) !== null && _a !== void 0 ? _a : (function () { });
        store.onPreviewChange = (_b = props.onPreviewChange) !== null && _b !== void 0 ? _b : (function () { });
    }, [
        mode,
        toolbar,
        theme,
        toolbarItems,
        store,
        props.onChange,
        props.onPreviewChange,
    ]);
    (0, react_1.useEffect)(function () {
        var _a;
        (_a = store.editor) === null || _a === void 0 ? void 0 : _a.dispatch({
            changes: {
                from: 0,
                to: store.editor.state.doc.length,
                insert: markdown !== null && markdown !== void 0 ? markdown : '',
            },
        });
    }, [markdown, store.editor]);
    return (react_1.default.createElement(antd_1.ConfigProvider, { theme: {
            token: {
                colorPrimary: '#00b96b',
            },
        } },
        react_1.default.createElement(layout_1.default, { store: store })));
};
exports.default = MarkPlus;
//# sourceMappingURL=index.js.map