import { EditorView } from '@codemirror/view';
import { ReactElement } from 'react';
export declare class ModalState {
    private store;
    isOpen: boolean;
    constructor(store: Store);
    open(): void;
    close(): void;
}
declare class Preferences {
    mode: 'editor' | 'preview' | 'both';
    toolbar: 'show' | 'hide' | 'none';
    theme: 'light' | 'dark' | 'auto';
    toolbarItems: (string | ReactElement)[];
}
export declare class Store {
    uid: string;
    editor: EditorView;
    onChange: (markdown: string) => void;
    onPreviewChange: (html: string) => void;
    modals: {
        about: ModalState;
        emoji: ModalState;
        fontAwesome: ModalState;
    };
    preferences: Preferences;
}
export {};
