"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Store = exports.ModalState = void 0;
var ModalState = /** @class */ (function () {
    function ModalState(store) {
        this.store = store;
        this.isOpen = false;
    }
    ModalState.prototype.open = function () {
        this.isOpen = true;
    };
    ModalState.prototype.close = function () {
        var _a;
        this.isOpen = false;
        (_a = this.store.editor) === null || _a === void 0 ? void 0 : _a.focus();
    };
    return ModalState;
}());
exports.ModalState = ModalState;
var Preferences = /** @class */ (function () {
    function Preferences() {
        this.mode = 'both';
        this.toolbar = 'show';
        this.theme = 'auto';
        this.toolbarItems = [];
    }
    return Preferences;
}());
var counter = 0;
var Store = /** @class */ (function () {
    function Store() {
        this.uid = "markplus-".concat(counter++);
        this.onChange = function () { };
        this.onPreviewChange = function () { };
        this.modals = {
            about: new ModalState(this),
            emoji: new ModalState(this),
            fontAwesome: new ModalState(this),
        };
        this.preferences = new Preferences();
    }
    return Store;
}());
exports.Store = Store;
//# sourceMappingURL=store.js.map